// file MyMap.h
// author Edda Nourbakhsh


#pragma once




#ifdef MyMap_EXPORTS
#define MyMap_API __declspec(dllexport)
#else
#define MyMap_API __declspec(dllimport)
#endif
#define MapSegmentName "MyMapSegment"


#include <windows.h>
#include <iostream>
#include <vector>
#include <sstream>

#include <string>
#include "SharedMemoryMapGuard.h"


typedef std::map< unsigned int, std::string > MyMapType;
typedef void * (*Signature)();


class MyMap;


extern "C" MyMap_API MyMap * InitMap(char const * name);


class MyMap
{

public:
	MyMap(char const * name)
		: mName(name)
		, mMapGuard(
			SharedMemoryName,
			MapSegmentName,
			&(MyMap::getMyMapPtr)
			)
	{
		std::string insertValue(mName);
		insertValue.append("_insert");
		mMyMap.insert(
					MyMapType::value_type(1u, insertValue)
					);

		//MyMapType * myMapInSharedMemory = getSharedMemoryMap(search);
		//if (myMapInSharedMemory != nullptr)
		//	myMapInSharedMemory->insert(
		//		MyMapType::value_type(1u, insertValue)
		//		);
		//else
		//	std::cout << "Hello, it's me: " << mName.c_str() << ". I could not get instance from shared memeory." << std::endl;
	}

	///////////////


public:
	static void * getMyMapPtr()
	{
		return &mMyMap;
	}

	///////////////

public:
	void log() const
	{
		SharedMemoryMapGuard< Signature >::mMapType * pMap
			= mMapGuard.getMapPtr();
		if (pMap == nullptr)
		{
			return;
		}

		//typedef std::map< void *, Signature > mMapType;
		//typedef MyMapType * (* Signature)(char const *);
		std::for_each(pMap->begin(), pMap->end(),
				[this](SharedMemoryMapGuard< Signature >::mMapType::value_type item)
		{
			std::cout << std::endl;
			std::cout << "pMap key: " << (long)item.first << std::endl;

			MyMapType const * m = (MyMapType const *)item.second();

			std::for_each(
				m->begin(), m->end(),
				[](MyMapType::value_type item)
			{
				std::cout << "myMap first: " << item.first << "   myMap second: " << item.second.c_str() << std::endl;
			});

		});

	}

	///////////////

protected:
	MyMapType const * getSharedMemoryMap(
		char const * const search
		) const
	{
		SharedMemoryMapGuard< Signature >::mMapType * pMap
			= mMapGuard.getMapPtr();
		if (pMap == nullptr)
		{
			return nullptr;
		}

		MyMapType::const_iterator myMapIt;

		//typedef std::map< void *, Signature > mMapType;
		//typedef MyMapType * (* Signature)(char const *);
		SharedMemoryMapGuard< Signature >::mMapType::iterator fctIt
			= std::find_if(pMap->begin(), pMap->end(),
				[this, &myMapIt, &search](SharedMemoryMapGuard< Signature >::mMapType::value_type item) -> bool
		{
			MyMapType const * m = (MyMapType const *)item.second();

			myMapIt = std::find_if(
				m->begin(), m->end(),
				[&search](MyMapType::value_type item) -> bool
			{
				return item.second.compare(search) == 0;
			});

			if (myMapIt == m->end())
			{
				return false;
			}

			//// prevent endless recursion
			//if (this == myMapIt->second.get())
			//{
			  //return false;
			//}
	//
			return true;

		});


		if (fctIt != pMap->end())
		{
			if (myMapIt != ((MyMapType const *)(fctIt->second()))->end())
			{
				return ((MyMapType const *)(fctIt->second()));
			}
		}

		return nullptr;
	}

	///////////////

public:
	static std::vector< std::shared_ptr < MyMap > > mInstances;

private:
	std::string mName;
	SharedMemoryMapGuard< Signature > mMapGuard;
	static MyMapType mMyMap;

};
